unit GWCOMDemo_Basic;

interface
uses GWCOMDemo_Base;

Type
  //-------------------------------
  TGWCOMDemo_Basic = class(TGWCOMDemo_Base)
  //-------------------------------
  public
    procedure Demo_Run_Inner;
    procedure Demo_Run; override;
  end;

//-------------------------------
implementation
//-------------------------------
uses GWMonOLE, GWDemoCode;

//ShowBegin
// Demonstrate basic RefCount behaviors

//---------------------------------------
procedure TGWCOMDemo_Basic.Demo_Run_Inner;
//---------------------------------------
Var
  Pascal_Object_1, Pascal_Object_2, Pascal_Object_3:  TGWMonInterfacedObject;
  COM_Interface_1, COM_Interface_2, COM_Interface_3:  IUnknown;
Begin
  Pause('000');
  Pascal_Object_1 := TGWMonInterfacedObject.Create(Mon);
  Pause('010'); // Note RefCount is zero

  Pascal_Object_2 := Pascal_Object_1;
  Pause('020'); // Note another ordinary reference does not increment RefCount

  COM_Interface_1 := Pascal_Object_1;
  Pause('030'); // RefCount incremented

  COM_Interface_2 := Pascal_Object_2;
  Pause('040'); // Another reference to same interface increments RefCount

  COM_Interface_1 := nil;
  Pause('050'); // We lost a reference, RefCount decremented

  Pascal_Object_3   := TGWMonInterfacedObject.Create(Mon);
  COM_Interface_3   := Pascal_Object_3;
  Pause('060'); // Another new object

  COM_Interface_2 := COM_Interface_3;
  Pause('070'); // Increments second , decrements first and destroys

  // There is still a live object, but it will lose all its references
  // when they go out of scope at end of this procedure
end;

//---------------------------------------
procedure TGWCOMDemo_Basic.Demo_Run;
//---------------------------------------
Begin
  Pause('Begin');
  Demo_Run_Inner;
  Pause('End');   // Check that all objects are deleted by now!
end;
//ShowEnd


initialization
  DemoCode_Mgr.Add(TGWCOMDemo_Basic.Create('COM Demo Basic','GWCOMDemo_Basic.pas'));
end.

